

Sympa 2 offre la possibilite de CHOISIR PAR LISTE la methode
de stockage du fichier des abonnes :

     1. file : Comme auparavant, dans un FICHIER TEXTE
     2. database : Dans une BASE DE DONNEES (SGBD)
     3. include : INCLUSION de donnees EXTERNES :
	    o Base de donnees (interogee en SQL)
	 ou o Annuaire LDAP

Modules Perl :
-------------

! Aucun module supplementaire ne doit etre installe si vous gardez
! les listes d'abonnes sous forme textuelle. 

Dans le cas d'un SGBD, Sympa utilise une librairie Perl standard :
DBI (DataBase Interface). Vous devez donc installer des modules Perl 
supplementaires (disponible sur CPAN) :
     o le module DBI (couramment DBI-1.06)
     o le module DBD correspondant a votre base de donnees (MySQL,
       PostgreSQL, Oracle, ...). Le module pour MySQL s'appelle
       Msql-Mysql-modules (l'installation de ce module necessite l'install.
       de 2 autres modules : Data-Dumper et Data-ShowTable).

La fonctionnalite d'acces a un annuaire LDAP necessite l'installation
du module Perl Net::LDAP (perlldap).

[CPAN : ftp://ftp.pasteur.fr/pub/computing/CPAN//CPAN.html]


Objectifs :
----------

Le passage a une structure SGBD pour les donnees de Sympa est un passage
oblige dans le developpement d'une interface Web (admin + utilisateur),
WWSympa. Le principe de cette interface etant base sur un acces par abonne
et non par liste, il est donc primordial d'optimiser le temps d'execution
d'un "WHICH". Le SGBD resout en outre les problemes de concurrence 
d'acces aux donnees entre Sympa et WWSympa (Lock, Commit).

La compatibilite a ete assuree avec les versions anterieures de Sympa, 
les listes pouvant etre individuellement etre configurees en mode
fichier, SGBD interne ou Include externe (ldap ou sql dans cette version).

Sympa fait un "dump" des fichiers d'abonnes des listes
en mode database a chaque arret ; vous pouvez donc facilement
repasser en mode File :
	1 arreter Sympa (kill -TERM)
	2 renommer abonnes.db.dump en abonnes
	3 changer config : user_data_source file

Les listes dont la liste des abonnes est le resultat d'une requete
externe (user_data_source include) ont les limitations suivantes :
	- abonnement invalide
	- desabonnement invalide
	- pas de champ gecos (commentaire), sauf LDAP.

Exemple d'utilisation de ce type de listes :
	Listes des etudiants n'ayant pas encore passe l'U.V. z.

Structure de la Base de Donnees :
-----------------------------------

 	 ---------	 	 -----------
	| User    |		| Subscriber|
	 ---------  1,n	    1,1	 -----------  1,1    0,n   
	|*email   |<----------->|*user,list |<---------->~sympa/expl/<listname>/config
	| gecos	  |		| date	    |
	| password|		| visibility|
         ---------		| reception |
				 -----------

La jointure entre les tables User et Subscriber se fait sur les champs
email_user et user_subscriber.

Creation de la Base de Donnees avec MySQL (http://www.tcx.se/) :
-----------------------------------------------------------------

en tant que root :
	% mysql  < create_db.mysql

Chargement d'une liste d'abonnes dans la base de donnees :
--------------------------------------------------------------

Editez load_abonnes.pl et adaptez les parametres $db_xxx a votre 
configuration.

Pour charger une liste dans le SGBD :
	% load_abonnes.pl <nom_de_liste>


Pb de Compatibilite entre SGBDs :
------------------------------

Certaines differences dans l'implementation du langage SQL entre SGBDs empechent
pour l'instant l'utilisation de Sympa avec un autre SGBD que MySQL. Les principales
differences (par rapport a PostgreSQL) sont les suivantes :

o requete de creation de la base de donnees, en particulier variantes pour
  la creation des Index.
  
o certains SGBD sont sensibles a la casse (PostgreSQL), d'autres pas (MySQL).
  Les libriairies d'acces au SGBD considerent qu'il est case-insensitive.
  
o MySQL implemente la tres pratique commande REPLACE que ne reconnait pas
  PostgreSQL. 
  
o Les fonction de conversion depuis/vers une date systeme UNIX varient :
    + MySQL :  FROM_UNIXTIME(%d)
               UNIX_TIMESTAMP(%s)
	       
    + PostgreSQL : 'epoch'::datetime + '%d sec'
                   date_part('epoch',%s)                   

Compte-tenu de l'ouverture du systeme DBI/DBD, il devrait rapidement etre 
possible d'utilisation n'importe quel autre SGBD conjointement a Sympa.

Configuration de la base de donnees (sympa.conf) :
---------------------------------------------------

5 parametres permettent de definir la base de donnees stoquant les 
information sur les abonnes :

	o db_type
	  Systeme de Gestion de la Base de Donnees (mysql, Pg, oracle,...)

	o db_name
	  Nom de la base de donnees.

	o db_host
 	  Nom de la machine hebergeant la base de donnees.

	o db_user
	  Usager ayant les privileges d'acces a la base
	  de donnees.

	o db_passwd
	  Mot de passe de l'usager.

Configuration de la source de donnees par liste :
-----------------------------------------------

Parametre user_data_source

Ce parametre definit la structure des donnees relatives
aux abonnes : user_data_source < file | database | include >

       o user_data_source file (defaut)
         Les donnees sur les abonnes sont stoquees dans un fichier, comparable
	 au fichier de configuration de la liste. Ce fichier est organise en
	 paragraphe : date, email, gecos, reception, visibility.

       o user_data_source database
         Les informations sur les abonnes sont stoquees dans une Base de
	 Donnees interogeable par SQL. L'acces a la base de donnees se fait
	 par l'intermediaire de l'interface DBI de Perl. Le module DBI doit 
	 etre prealablement installe ainsi que le driver (DBD) correspondant
	 a votre SGBD. Vous devez indiquer a Sympa les parametres d'acces a
	 sa base de donnees dans sympa.conf. 
	 
       o user_data_source include
         La liste des abonnes est importee depuis une source externe. Ni
	 l'abonnement, ni le desabonnement ne sont donc possibles. La source
	 de donnees (LDAP, SQL_Query ou  File) est definie dans un paragraphe
	 include_ldap, include_sql_query ou include_file.


Parametre include_sql_query

Ce paragraphe definit les parametres d'une requete SQL retournant une liste
d'abonnes. Ce parametre n'est pris en compte que si user_data_source est
positionne a "include". Cette fonctionnalite necessite l'installation prealable 
du module Perl DBI (DataBase Interface) ainsi que du DBD correspondant au SGBD.
Ex :
    db_type mysql
    db_name personnel
    host serveur.votre.organisme
    user consult
    passwd consult
    sql_query SELECT DISTINCT mel_employe from employes where service = 'grande distribution'
    
        o db_type <mysql | Pg | Oracle>
	Systeme de Gestion de Base de Donnees distant. Le module DBD Perl 
	correspondant doit etre prealablement install. Actuellement, seul 
	mysql est supporte.
	
	o db_name <nom de la base>
	Nom de la base de donnees distante.
	
	o host <machine hote>
	Nom de la machine hebergeant la base de donnees.
	
	o user <usager>
	Usager ayant les droit d'acces pour la consultation de la base.
	
	o passwd <mot de passe>
	Mot de passe associe a l'usager precite.
	
	o sql_query <requete SQL>
	Requete SQL retournant une liste d'adresses electroniques.
	
	
Parametre include_ldap_query

Ce paragraphe definit les parametres d'une requete LDAP retournant une liste
d'abonnes. Ce parametre n'est pris en compte que si user_data_source est
positionne a "include". Cette fonctionnalite necessite l'installation
prealable du module Perl Net::LDAP (perlldap).

Ex :
    include_ldap_query
    host ldap.bigfoot.com
    filter (&(cn=aumont) (c=fr))
	
        o host <machine hote>
	Nom du serveur hebergeant le repertoire LDAP.
	
	o port <port> (389 par defaut)
	Port recevant les requetes sur le serveur distant.
	
	o user <usager>
	Usager ayant les droit d'acces pour la consultation du repertoire
	si ce dernier n'est pas public.
	
	o passwd <mot de passe>
	Mot de passe de l'usager.
	
	o filter <requete>
	Ce parametre definit un "search filter" LDAP, conforme au RFC 2254.





