## This module does just the initial setup for the international
## messages.

package Language;

require Exporter;
use Carp;
@ISA = qw(Exporter);
@EXPORT = qw(Msg);

use strict;
use Locale::Msgcat;
use Log;
use Version;

my $Message = new Locale::Msgcat;
my $isopen;

sub SetLang {
   my $lang = shift;

#   $lang ||= 'default.cat';

   ## Now check if the file exists
   return undef unless (-r "$Conf::Conf{'msgcat'}/$lang.cat");

   $Message->catclose() if ($isopen);
   $isopen = $Message->catopen("$Conf::Conf{'msgcat'}/$lang.cat", 1);
   
   if ($isopen) {
       do_log('info', 'Using locale file %s.cat version %s', $lang, Msg(1, 102, $Version));
   }else {
       do_log('info','Locale file %s.cat not used, using builtin messages', $lang);
   }

   return $isopen;
}

sub Msg {
#    print STDERR "Msg $_[0] $_[1]\n";
   if ($isopen) {
      $Message->catgets(@_);
   }else {
      $_[2];
   }
}

1;
